# Lista (List)

l = [1, 2, 3, 4, 5]
print(l, type(l))
l += [-3, -3, -3]
print(l)
print('len:', len(l))
print('sum:', sum(l))
l.append(-6)
print(l)
l.pop()
print(l)
l = [1, 2, "Matf", 12.3, [1, 2, 3], [[1,2], [3,4]], 1]
print(l)
print(l[2])
print(l[-2])
print(l[2:])
print(l[:-2])
print(l.count(1)) # broj pojavljivanja elementa u listi

l1 = [2, 3, 34, 341, 2, -23, 213]
print('len:', len(l1))
print('sum:', sum(l1)) # elementi moraju biti istog tipa
print('max: ', max(l1)) # elementni moraju biti istog tipa
print(l.count(2))

l2 = l1 * 3
print(l2)
l3 = [2, 4]
print(l1 < l3) # leksikografsko porednjenje

l4 = ['abc', 1.23, [1,2], (5,6,7), 'matf', 5, 'pp']
try:
    print(l1 >= l4)
except TypeError as err:
    print("Greska. Python3 ne poredi razlicite tipove: ", err)

print(l4.index('matf')) # indeks prvoj pojavljivanja elementa

l4.insert(2, 'def') # ubacivanje elementa na indeks
l4.remove((5, 6, 7)) # izbacivanje elementa iz liste (prvog pojavljivanje)
print(l4)

del l4[1:4] # brisanje elemenata liste od indeksa 1 do indeksa 4
print(l4)

# Torke (Tuple)
# Torka predstavlja strukturu podataka koja je uredjena i imutabilna 
print('\n----------------------------------\n')
t = ("jabuka", "banana", "visnja", "pomorandza", "kivi", "lubenica", "mango")
print(t[2:5])
try:
    t[0] = 11
except TypeError:
    print("Torke su imutabilne.")

# izmena 
t = list(t)
t[0] = 11
t = tuple(t)
print(t)
